<template>
  <transition :name="animation">
    <pageWrapper
      v-if="show"
      ref="pageWrapper"
      backable
      gradient
      @back="close"
      @close="close"
      :title="$t('history.details.title')">
      <div class="pageCard-padding text-center text-bold text-huge">
        <div>
          {{formatDate(data.timestamp, 'iso')}}
        </div>
        <div class="text-medium text-normal color-info">
          {{formatDate(data.timestamp)}} (GMT{{new Date().getTimezoneOffset() < 0 ? '+' : '-'}}{{Math.abs((new Date().getTimezoneOffset())/(60))}})
        </div>
      </div>
      <div style="padding: 0px 10px;">
        <PageCard>
          <div
            class="history_details">
            <div
              class="history_details-bets"
              v-if="data.myWins.length || data.myLosses.length">
              <div>
                <div class="history_details-header color-info">
                  {{$t('history.myBets')}}:
                </div>
                <div
                  class="history_details-bets-inner">
                  <div
                    class="item flex flex-middle"
                    v-for="(item, key) in data.myWins"
                    :key="key">
                    <div class="item-number item_winner">{{item.showingNumber}}</div>
                    <div class="item-amount">{{item.amount}} EOS / {{item.sum}} EOS</div>
                  </div>
                </div>
                <div class="history_details-bets-inner flex">
                  <div
                    class="item flex flex-middle"
                    v-for="(item, key) in data.myLosses"
                    :key="key">
                    <div class="item-number item_loose">{{item.showingNumber}}</div>
                    <div class="item-amount">{{item.amount}} EOS</div>
                  </div>
                </div>
              </div>
              <div class="history_details-footer">
                <div class="flex flex-middle flex-between">
                  <div class="color-info">{{$t('common.sum')}}:
                    <span class="color-white">{{data.stats.player && data.stats.player.bets_amount}} EOS</span>
                  </div>
                  <div class="color-info">{{$t('common.win')}}:
                    <span class="color-green">{{data.stats.player && data.stats.player.wins.amount}} EOS</span></div>
                </div>
              </div>
            </div>
            <div class="history_details-bets">
              <div>
                <div class="history_details-header color-info">
                  {{$t('history.otherBets')}}:
                </div>
                <div class="history_details-bets-inner">
                  <div
                    class="item flex flex-middle"
                    v-for="(item, key) in data.otherWins"
                    :key="key">
                    <div class="item_winner-alien item-number">{{item.showingNumber}}</div>
                    <div class="item-amount">{{item.amount}} EOS / {{item.sum}} EOS</div>
                  </div>
                </div>
                <div class="history_details-bets-inner flex">
                  <div
                    class="item flex flex-middle"
                    v-for="(item, key) in data.otherLosses"
                    :key="key">
                    <div class="item_default item-number">{{item.showingNumber}}</div>
                    <div class="item-amount">{{item.amount}} EOS</div>
                  </div>
                </div>
              </div>
              <div class="history_details-footer">
                <div class="flex flex-middle flex-between">
                  <div class="color-info">{{$t('common.sum')}}:
                    <span class="color-white">{{getOtherBetsAmount(data)}} EOS</span>
                  </div>
                  <div class="color-info">{{$t('common.win')}}:
                    <span class="color-orange">{{getOtherWinsAmount(data)}} EOS</span></div>
                </div>
              </div>
            </div>
            <div class="history_details_body">
              <div class="history_details-start flex flex-middle flex-start">
                <div class="pr-20">
                  <div class="color-accent">{{$t('history.details.startHash')}}</div>
                  <div class="hash">{{data.house_seed_hash}}</div>
                </div>
                <img
                  src="~/static/icons/copy.png"
                  @click="copy(data.house_seed_hash)"
                  class="icon"
                  alt="">
              </div>
              <div class="history_details-info">
                <div class="details-info flex flex-middle">
                  <div class="info-mockup">
                    α
                  </div>
                  <div class="history_details-info-description details-info-description">
                    <div class="color-info">{{$t('history.details.houseSeed')}}</div>
                    <div class="hash">{{data.house_seed}}</div>
                  </div>
                  <img
                    src="~/static/icons/copy.png"
                    @click="copy(data.house_seed)"
                    class="icon"
                    alt="">
                </div>
              </div>
              <div class="flex flex_column history_details-arrowWrapper">
                <div id="arrow-details"></div>
                <div class="history_details-info details-info">
                  <div class="flex flex-middle">
                    <div class="info-mockup">
                      β
                    </div>
                    <div class="history_details-info-description details-info-description">
                      <div class="color-info">{{$t('history.details.compoundSeed')}}</div>
                      <div class="hash">{{data.compound_hash}}</div>
                    </div>
                    <img
                      src="~/static/icons/copy.png"
                      @click="copy(data.compound_hash)"
                      class="icon"
                      alt="">
                  </div>
                </div>
                <div class="history_details-info">
                  <div class="checkResult_body flex flex-middle flex-end">
                    <div class="info-mockup">
                      α
                    </div>
                    <span class="margin-left margin-right"><i class="i-icon-plus"></i></span>
                    <div class="info-mockup">
                      β
                    </div>
                    <img
                      class="gear margin-left-big margin-right-big"
                      src="~/static/icons/settings-gears.svg"
                      alt="">
                    <div
                      class="info-mockup"
                      :class="amIWin(data)">
                      {{data.win || 0}}
                    </div>
                    <div class="check-button margin-left">
                      <Btn
                        square
                        @click="checking">{{$t('history.details.checkResult')}}
                      </Btn>
                    </div>
                  </div>
                </div>
                <div
                  class="history_details-info"
                  v-if="false">
                  <div class="text-center">
                    <a
                      href=""
                      class="color-accent-light">{{$t('history.details.howItWorks')}}</a>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <CheckResult @close="close"></CheckResult>
        </PageCard>
      </div>
    </pageWrapper>
  </transition>
</template>

<script>
  import Btn from '~/components/UI/Btn';
  import SvgArrow from './svg';
  import copyClipboard from '~/components/utils/copy';
  import pageWrapper from '~/components/common/pageWrapper';
  import PageCard from '~/components/UI/PageCard';
  import {flooring} from "../utils";

  //import scroll from '~/components/utils/scroll';

  export default {
    name: "HistoryDetails",
    data() {
      return {
        animation: 'slideTo-left',
        svg: null
      }
    },
    components: {
      pageWrapper,
      PageCard,
      Btn,
      CheckResult: () => import('~/components/checkResult'),
    },
    computed: {
      historyGameHash() {
        return this.$store.state.gameDetails.hash;
      },
      show() {
        return this.$store.state.gameDetails.show;
      },
      data() {
        return this.$store.getters['gameDetails/details'];
      }
    },
    methods: {
      formatDate(timestamp, type = 'locale') {
        const date = new Date(timestamp);
        switch (type) {
          case 'locale': {
            return date.toLocaleDateString() + '    ' + date.toLocaleTimeString()
          }
          case 'iso': {
            const isoDate = date.toISOString().replace('Z', '');
            return new Date(isoDate).toLocaleDateString() + '    ' + new Date(isoDate).toLocaleTimeString()
          }
        }
      },
      amIWin(data) {
        let state = 'nobody';
        if (data.stats.total.bets_amount && !data.stats.total.wins.count) state = 'owner';
        if (data.stats.total.wins.count) state = 'other';
        if (data.stats.player && data.stats.player.wins.count) state = 'win';
        if (data.stats.player && !data.stats.player.wins.count && data.stats.player.losses.count) state = 'lose';
        return state;
      },
      getOtherBetsAmount(data) {
        return data.stats.player ? flooring(data.stats.total.bets_amount - data.stats.player.bets_amount) : data.stats.total.bets_amount
      },
      getOtherWinsAmount(data) {
        let otherAmount = data.stats.total.wins.amount;
        if (data.stats.player) {
          otherAmount = otherAmount - data.stats.player.wins.amount;
        }
        return flooring(otherAmount);
      },
      copy(text) {
        this.ga('cop', true);
        copyClipboard(text, this.$t('common.copied'));
      },
      checking() {
        this.ga('check', true);
        this.$store.dispatch('checkResult/fetch');
      },
      close() {
        this.animation = 'slideTo-right';
        this.$nextTick(_ => {
          this.$store.commit('gameDetails/SET_SHOWING', false);
        });
      },
      initSvg() {
        if (!this.svg) this.svg = new SvgArrow('#arrow-details');
        this.svg.init();
      }
    },
    watch: {
      'show': function () {
        if (this.show) {
          this.animation = 'slideTo-left';
          this.$nextTick(_ => {
            this.initSvg();
            this.$onWrapperScroll.setContainer(this.$refs['pageWrapper'].$el);
            this.$refs['pageWrapper'].$el.onscroll = (e) => {
              this.$onWrapperScroll.scroll(e);
            };
          });
        } else {
          this.svg && this.svg.clear();
        }
      }
    }
  }
</script>
